//  this version is misbehaving.  BT slider bar for turn and backward speeds.  BT mode functional, but Auto is misbehaving.
#include <NewPing.h>
#include <Servo.h>
#include <Wire.h>
#include <SoftwareSerial.h>   //Software Serial Port for BT
#define RxD 3
#define TxD 2
 
int automode = 0;
int gospeed = 0;
int pingrng = 0;
int cmdsent = 0;
char instruction;
byte key;
byte val;
long timer;
 
SoftwareSerial blueToothSerial(RxD,TxD); //tell BT what pins to us 
 
void setup() {
  Serial.begin(9600);
  Wire.begin ();
  timer = millis();
  //init bluetooth
  setupBlueToothConnection();  // start BT connection 
}
 
void loop() {
  if(blueToothSerial.available()>=2)  {
      key = blueToothSerial.read();
      val = blueToothSerial.read();
    }

  if (key==7 && val==1) { automode=1; key=9; cmdsent=0;} //automatic operation
  else if (key==7 && val==0){ automode=0; key=9; cmdsent=0;} //BT operation
  
  //
  //  If automode=0, we are in manual mode, and control stays here on this Arduino
  //  If automode=1, then we pass control to the slave Arduino to roam automatically
  
  if (automode==1 && cmdsent==0) { instruction='A'; cmdsent=0; Serial.println("Auto mode"); }
  if (automode==0 && cmdsent==0) { instruction='M'; cmdsent=0; Serial.println("Manual mode"); }
  if (cmdsent==0) { driveSlave(); cmdsent=1; } // Send the command to switch modes
          
  if (automode==0){  // If manual mode, take commands from BT - just an expensive RC toy
      switch(key) {
        case 1:   //go forward
           instruction='F';
           driveSlave();
           break;
         case 2:  //go backward
           instruction='B';
           driveSlave();
           break;
         case 3:  //turn left
           instruction='L';
           driveSlave();           
           break;
         case 4:  //turn right
           instruction='R';
           driveSlave();
           break;
         case 5:  //Stop
           instruction='S';
           driveSlave();
           break;
         case 6:  //increase speed
           instruction='+';
           driveSlave();           
           break;
         case 8:  // Reset the speed 
           instruction='0';
           driveSlave();     
           break; 
         case 10:  //descrease speed
           instruction='-';
           driveSlave();           
           break; 
        }
  }
  
      if (millis() - timer > 3000)  //every 3 secound request the speed setting from the slave 
      {
        Wire.requestFrom(42,1);
        while (Wire.available())
          {
            gospeed = Wire.read();
            blueToothSerial.write(207); 
            blueToothSerial.write(highByte(gospeed)); 
            blueToothSerial.write(lowByte(gospeed)); 
            Serial.print("Gospeed: ");
            Serial.println(gospeed);
            timer=millis();
          }
      }    
  }
  
void driveSlave() 
{     
      if (instruction != ' ') {
      Serial.print("sending to slave: ");
      Serial.println(instruction);
      Wire.beginTransmission (42);
      Wire.write(instruction);
      Wire.endTransmission();
      instruction=' ';  
      key=9;
      val=0;
    }
}

void setupBlueToothConnection()
{
  blueToothSerial.begin(38400); //Set BluetoothBee BaudRate to default baud rate 38400
  blueToothSerial.print("\r\n+STWMOD=0\r\n"); //set the bluetooth work in slave mode
  blueToothSerial.print("\r\n+STNA=StevesBTSlave\r\n"); //set the bluetooth name as "SeeedBTSlave"
  blueToothSerial.print("\r\n+STOAUT=1\r\n"); // Permit Paired device to connect me
  blueToothSerial.print("\r\n+STAUTO=1\r\n"); // Auto-connection should be forbidden here
  delay(2000); // This delay is required.
  blueToothSerial.print("\r\n+INQ=0\r\n"); //make the slave bluetooth inquirable 
  Serial.println("The slave bluetooth is inquirable!");
  delay(4000); // This delay is required.
  blueToothSerial.flush();
}
